"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
function main(compiler, next) {
    return __awaiter(this, void 0, void 0, function () {
        var bootPath, file, parts;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    bootPath = (compiler.target.version.startsWith('4') ? 'src/' : 'lib/internal/bootstrap_') + 'node.js';
                    return [4 /*yield*/, compiler.readFileAsync(bootPath)];
                case 1:
                    file = _a.sent();
                    parts = file.contents.split('function(process) {');
                    file.contents =
                        parts[0] + "function(process) {" + "\"use strict\";\r\n//add placeholder patches so methods can be monkeypatched after being dereferenced\r\nvar __nexe_patches = (process.nexe = { patches: {} }).patches;\r\nfunction __nexe_noop_patch(original) {\r\n    var args = [];\r\n    for (var _i = 1; _i < arguments.length; _i++) {\r\n        args[_i - 1] = arguments[_i];\r\n    }\r\n    return original.call.apply(original, [this].concat(args));\r\n}\r\nfunction __nexe_patch(obj, method, patch) {\r\n    __nexe_patches[method] = patch;\r\n    var original = obj[method];\r\n    obj[method] = function () {\r\n        var args = [];\r\n        for (var _i = 0; _i < arguments.length; _i++) {\r\n            args[_i] = arguments[_i];\r\n        }\r\n        return (_a = __nexe_patches[method]).call.apply(_a, [this, original].concat(args));\r\n        var _a;\r\n    };\r\n}\r\n__nexe_patch(process.binding('fs'), 'internalModuleReadFile', __nexe_noop_patch);\r\n__nexe_patch(process.binding('fs'), 'internalModuleStat', __nexe_noop_patch);\r\n" + parts[1];
                    return [4 /*yield*/, compiler.setFileContentsAsync('lib/_third_party_main.js', "\"use strict\";\r\nvar fs = require('fs');\r\nvar fd = fs.openSync(process.execPath, 'r');\r\nvar stat = fs.statSync(process.execPath);\r\nvar footer = Buffer.alloc(32, 0);\r\nfs.readSync(fd, footer, 0, 32, stat.size - 32);\r\nif (!footer.slice(0, 16).equals(Buffer.from('<nexe~~sentinel>'))) {\r\n    throw 'Invalid Nexe binary';\r\n}\r\nvar contentSize = footer.readDoubleLE(16);\r\nvar resourceSize = footer.readDoubleLE(24);\r\nvar contentStart = stat.size - 32 - resourceSize - contentSize;\r\nvar resourceStart = contentStart + contentSize;\r\nObject.defineProperty(process, '__nexe', (function () {\r\n    var nexeHeader = null;\r\n    return {\r\n        get: function () {\r\n            return nexeHeader;\r\n        },\r\n        set: function (value) {\r\n            if (nexeHeader) {\r\n                throw new Error('__nexe cannot be reconfigured');\r\n            }\r\n            nexeHeader = Object.assign({}, value, {\r\n                layout: {\r\n                    stat: stat,\r\n                    contentSize: contentSize,\r\n                    contentStart: contentStart,\r\n                    resourceSize: resourceSize,\r\n                    resourceStart: resourceStart\r\n                }\r\n            });\r\n            Object.freeze(nexeHeader);\r\n        },\r\n        enumerable: false,\r\n        configurable: false\r\n    };\r\n})());\r\nvar contentBuffer = Buffer.from(Array(contentSize));\r\nfs.readSync(fd, contentBuffer, 0, contentSize, contentStart);\r\nfs.closeSync(fd);\r\nvar Module = require('module');\r\nprocess.mainModule = new Module(process.execPath, null);\r\nprocess.mainModule.loaded = true;\r\nprocess.mainModule._compile(contentBuffer.toString(), process.execPath);\r\n")];
                case 2:
                    _a.sent();
                    return [2 /*return*/, next()];
            }
        });
    });
}
exports.default = main;
